| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Protected Member Functions | Private Member Functions | Private Attributes | List of all members
GaudiSequencer Class Reference

Sequencer for executing several algorithms, stopping when one is faulty. More...

`#include <GaudiAlg/GaudiSequencer.h>`

Inheritance diagram for GaudiSequencer:
[legend]
Collaboration diagram for GaudiSequencer:
[legend]

## Classes
class | AlgorithmEntry

## Public Member Functions
| GaudiSequencer (const std::string &name, ISvcLocator *pSvcLocator)
| Standard constructor. More...
| ~GaudiSequencer () override=default
| Destructor. More...
StatusCode | initialize () override
| Algorithm initialization. More...
StatusCode | execute () override
| Algorithm execution. More...
StatusCode | finalize () override
| Algorithm finalization. More...
StatusCode | beginRun () override
| Algorithm beginRun. More...
StatusCode | endRun () override
| Algorithm endRun. More...
void | membershipHandler (Property &theProp)
| for asynchronous changes in the list of algorithms More...
Public Member Functions inherited from GaudiAlgorithm
StatusCode | initialize () override
| standard initialization method More...
StatusCode | execute () override
| standard execution method More...
StatusCode | finalize () override
| standard finalization method More...
StatusCode | sysExecute () override
| the generic actions for the execution. More...
void | put (IDataProviderSvc *svc, DataObject *object, const std::string &address, const bool useRootInTES=true) const
| Register a data object or container into Gaudi Event Transient Store. More...
void | put (DataObject *object, const std::string &address, const bool useRootInTES=true) const
| Register a data object or container into Gaudi Event Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | get (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getIfExists (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | get (const std::string &location, const bool useRootInTES=true) const
| Templated access to the data from Gaudi Event Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getIfExists (const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
template<class TYPE >
TYPE * | getDet (IDataProviderSvc *svc, const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getDetIfExists (IDataProviderSvc *svc, const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
TYPE * | getDet (const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getDetIfExists (const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
bool | exist (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Check the existence of a data object or container in the Gaudi Transient Event Store. More...
template<class TYPE >
bool | exist (const std::string &location, const bool useRootInTES=true) const
| Check the existence of a data object or container in the Gaudi Transient Event Store. More...
template<class TYPE >
bool | existDet (IDataProviderSvc *svc, const std::string &location) const
| Check the existence of detector objects in the Gaudi Transient Detector Store. More...
template<class TYPE >
bool | existDet (const std::string &location) const
| Check the existence of detector objects in the Gaudi Transient Detector Store. More...
template<class TYPE , class TYPE2 >
Gaudi::Utils::GetData< TYPE >::return_type | getOrCreate (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Get the existing data object from Gaudi Event Transient store. More...
template<class TYPE , class TYPE2 >
Gaudi::Utils::GetData< TYPE >::return_type | getOrCreate (const std::string &location, const bool useRootInTES=true) const
| Get the existing data object from Gaudi Event Transient store. More...
| GaudiAlgorithm (const std::string &name, ISvcLocator *pSvcLocator)
| Standard constructor (protected) More...
| ~GaudiAlgorithm () override=default
| destructor, virtual and protected More...
SmartIF< INTupleSvc > & | evtColSvc () const
| Access the standard event collection service. More...
| GaudiAlgorithm (const GaudiAlgorithm &)=delete
GaudiAlgorithm & | operator= (const GaudiAlgorithm &)=delete
template<class T >
Property * | declareProperty (const std::string &name, DataObjectHandle< T > &hndl, const std::string &doc="none") const
Public Member Functions inherited from GaudiCommon< Algorithm >
Gaudi::Utils::GetData< TYPE >::return_type | get (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
Gaudi::Utils::GetData< TYPE >::return_type | getIfExists (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Quicker version of the get function which bypasses the check on the retrieved data. More...
bool | exist (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Check the existence of a data object or container in the Gaudi Transient Event Store. More...
Gaudi::Utils::GetData< TYPE >::return_type | getOrCreate (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Get the existing data object from Gaudi Event Transient store. More...
DataObject * | put (IDataProviderSvc *svc, DataObject *object, const std::string &location, const bool useRootInTES=true) const
| Register a data object or container into Gaudi Event Transient Store. More...
TOOL * | tool (const std::string &type, const std::string &name, const IInterface *parent=0, bool create=true) const
| Useful method for the easy location of tools. More...
TOOL * | tool (const std::string &type, const IInterface *parent=0, bool create=true) const
| A useful method for the easy location of tools. More...
SmartIF< SERVICE > | svc (const std::string &name, const bool create=true) const
| A useful method for the easy location of services. More...
IUpdateManagerSvc * | updMgrSvc () const
| Short-cut to locate the Update Manager Service. More...
StatusCode | Error (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the error message and return with the given StatusCode. More...
StatusCode | Warning (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the warning message and return with the given StatusCode. More...
StatusCode | Info (const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const size_t mx=10) const
| Print the info message and return with the given StatusCode. More...
StatusCode | Print (const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const MSG::Level lev=MSG::INFO) const
| Print the message and return with the given StatusCode. More...
void | Assert (const bool ok, const std::string &message="", const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Assertion - throw exception if the given condition is not fulfilled. More...
void | Assert (const bool ok, const char *message, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Assertion - throw exception if the given condition is not fulfilled. More...
void | Exception (const std::string &msg, const GaudiException &exc, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and (re)-throw a given GaudiException. More...
void | Exception (const std::string &msg, const std::exception &exc, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and (re)-throw a given exception. More...
void | Exception (const std::string &msg="no message", const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and throw an exception with the given message. More...
const Statistics & | counters () const
| accessor to all counters More...
StatEntity & | counter (const std::string &tag) const
| accessor to certain counter by name More...
bool | typePrint () const
| Insert the actual C++ type of the algorithm/tool in the messages ? More...
bool | propsPrint () const
| Print properties at initialization ? More...
bool | statPrint () const
| Print statistical counters at finalization ? More...
bool | errorsPrint () const
| Print error counters at finalization ? More...
long | printStat (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of statistical counters More...
long | printErrors (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of error counters More...
long | printProps (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of properties More...
void | registerCondition (const std::string &condition, StatusCode(CallerClass::*mf)()=nullptr)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
void | registerCondition (const std::string &condition, CondType *&condPtrDest, StatusCode(CallerClass::*mf)()=NULL)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
void | registerCondition (char *condition, StatusCode(CallerClass::*mf)()=NULL)
| just to avoid conflicts with the version using a pointer to a template class. More...
void | registerCondition (TargetClass *condition, StatusCode(CallerClass::*mf)()=NULL)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
StatusCode | runUpdate ()
| asks the UpdateManagerSvc to perform an update of the instance (if needed) without waiting the next BeginEvent incident. More...
| GaudiCommon (const std::string &name, ISvcLocator *pSvcLocator)
| Algorithm constructor. More...
| GaudiCommon (const std::string &type, const std::string &name, const IInterface *parent)
| Tool constructor. More...
StatusCode | initialize () override
| standard initialization method More...
StatusCode | finalize () override
| standard finalization method More...
StatusCode | release (const IInterface *interface) const
| Manual forced (and 'safe') release of the active tool or service. More...
const Services & | services () const
| get the list of aquired services More...
const std::string & | context () const
| Returns the "context" string. Used to identify different processing states. More...
const std::string & | rootInTES () const
| Returns the "rootInTES" string. More...
const std::string | fullTESLocation (const std::string &location, const bool useRootInTES) const
| Returns the full correct event location given the rootInTes settings. More...
Public Member Functions inherited from Algorithm
| Algorithm (const std::string &name, ISvcLocator *svcloc, const std::string &version=PACKAGE_VERSION)
| Constructor. More...
| ~Algorithm () override=default
| Destructor. More...
StatusCode | sysStart () override
| Reinitialization method invoked by the framework. More...
StatusCode | sysInitialize () override
| Initialization method invoked by the framework. More...
StatusCode | sysReinitialize () override
| Reinitialization method invoked by the framework. More...
StatusCode | sysRestart () override
| Restart method invoked by the framework. More...
StatusCode | sysExecute () override
| The actions to be performed by the algorithm on an event. More...
StatusCode | sysStop () override
| System stop. More...
StatusCode | sysFinalize () override
| System finalization. More...
StatusCode | sysBeginRun () override
| beginRun method invoked by the framework. More...
StatusCode | sysEndRun () override
| endRun method invoked by the framework. More...
const std::string & | name () const override
| The identifying name of the algorithm object. More...
const Gaudi::StringKey & | nameKey () const override
const std::string & | type () const override
| The type of the algorithm object. More...
void | setType (const std::string &type) override
const std::string & | version () const override
unsigned int | index () const override
StatusCode | configure () override
| Dummy implementation of IStateful::configure() method. More...
StatusCode | terminate () override
| Dummy implementation of IStateful::terminate() method. More...
StatusCode | initialize () override
| the default (empty) implementation of IStateful::initialize() method More...
StatusCode | start () override
| the default (empty) implementation of IStateful::start() method More...
StatusCode | stop () override
| the default (empty) implementation of IStateful::stop() method More...
StatusCode | finalize () override
| the default (empty) implementation of IStateful::finalize() method More...
StatusCode | reinitialize () override
| the default (empty) implementation of IStateful::reinitialize() method More...
StatusCode | restart () override
| the default (empty) implementation of IStateful::restart() method More...
Gaudi::StateMachine::State | FSMState () const override
| returns the current state of the algorithm More...
Gaudi::StateMachine::State | targetFSMState () const override
| returns the state the algorithm will be in after the ongoing transition More...
bool | isExecuted () const override
| Has this algorithm been executed since the last reset? More...
void | setExecuted (bool state) override
| Set the executed flag to the specified state. More...
void | resetExecuted () override
| Reset the executed state of the Algorithm for the duration of the current event. More...
StatusCode | beginRun () override
| Algorithm begin run. More...
StatusCode | endRun () override
| Algorithm end run. This method is called at the end of the event loop. More...
bool | isEnabled () const override
| Is this algorithm enabled or disabled? More...
bool | filterPassed () const override
| Did this algorithm pass or fail its filter criterion for the last event? More...
void | setFilterPassed (bool state) override
| Set the filter passed flag to the specified state. More...
int | errorCount () const
| Get the number of failures of the algorithm. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
SmartIF< IService > | service (const std::string &name, const bool createIf=true, const bool quiet=false) const
| Return a pointer to the service identified by name (or "type/name") More...
template<class T >
SmartIF< T > | service (const std::string &name, bool createIf=true, bool quiet=false) const
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
SmartIF< IChronoStatSvc > & | chronoSvc () const
| The standard Chrono & Stat service, Return a pointer to the service if present. More...
SmartIF< IChronoStatSvc > & | chronoStatService () const
| Obsoleted name, kept due to the backwards compatibility. More...
SmartIF< IDataProviderSvc > & | detSvc () const
| The standard detector data service. More...
SmartIF< IDataProviderSvc > & | detDataService () const
| Obsoleted name, kept due to the backwards compatibility. More...
SmartIF< IConversionSvc > & | detCnvSvc () const
| The standard detector data persistency conversion service. More...
SmartIF< IConversionSvc > & | detDataCnvService () const
| Obsoleted name, kept due to the backwards compatibility. More...
SmartIF< IDataProviderSvc > & | eventSvc () const
| The standard event data service. More...
SmartIF< IDataProviderSvc > & | evtSvc () const
| shortcut for method eventSvc More...
SmartIF< IDataProviderSvc > & | eventDataService () const
| Obsoleted name, kept due to the backwards compatibility. More...
SmartIF< IConversionSvc > & | eventCnvSvc () const
| The standard event data persistency conversion service. More...
SmartIF< IConversionSvc > & | eventDataCnvService () const
| Obsoleted name, kept due to the backwards compatibility. More...
SmartIF< IHistogramSvc > & | histoSvc () const
| The standard histogram service. More...
SmartIF< IHistogramSvc > & | histogramDataService () const
| Obsoleted name, kept due to the backwards compatibility. More...
SmartIF< INTupleSvc > & | ntupleSvc () const
| The standard N tuple service. More...
SmartIF< INTupleSvc > & | ntupleService () const
| Obsoleted name, kept due to the backwards compatibility. More...
SmartIF< IRndmGenSvc > & | randSvc () const
| AIDA-based NTuple service Returns a pointer to the AIDATuple service if present. More...
SmartIF< IToolSvc > & | toolSvc () const
| The standard ToolSvc service, Return a pointer to the service if present. More...
SmartIF< IExceptionSvc > & | exceptionSvc () const
| Get the exception Service. More...
SmartIF< IAlgContextSvc > & | contextSvc () const
| get Algorithm Context Service More...
SmartIF< ITimelineSvc > & | timelineSvc () const
SmartIF< ISvcLocator > & | serviceLocator () const override
| The standard service locator. More...
SmartIF< ISvcLocator > & | svcLoc () const
| shortcut for method serviceLocator More...
SmartIF< IHiveWhiteBoard > & | whiteboard () const
bool | registerContext () const
| register for Algorithm Context Service? More...
StatusCode | createSubAlgorithm (const std::string &type, const std::string &name, Algorithm *&pSubAlg)
| Create a sub algorithm. More...
const std::vector< Algorithm * > * | subAlgorithms () const
| List of sub-algorithms. Returns a pointer to a vector of (sub) Algorithms. More...
std::vector< Algorithm * > * | subAlgorithms ()
| List of sub-algorithms. Returns a pointer to a vector of (sub) Algorithms. More...
StatusCode | setProperty (const Property &p) override
| Implementation of IProperty::setProperty. More...
StatusCode | setProperty (const std::string &s) override
| Implementation of IProperty::setProperty. More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| Implementation of IProperty::setProperty. More...
StatusCode | getProperty (Property *p) const override
| Implementation of IProperty::getProperty. More...
const Property & | getProperty (const std::string &name) const override
| Implementation of IProperty::getProperty. More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| Implementation of IProperty::getProperty. More...
const std::vector< Property * > & | getProperties () const override
| Implementation of IProperty::getProperties. More...
bool | hasProperty (const std::string &name) const override
| Implementation of IProperty::hasProperty. More...
PropertyMgr * | getPropertyMgr ()
StatusCode | setProperties ()
| Set the algorithm's properties. More...
template<class T >
Property * | declareProperty (const std::string &name, T &property, const std::string &doc="none") const
| Declare the named property. More...
Property * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="") const
| Declare remote named properties. More...
template<class T >
Property * | declareProperty (const std::string &name, ToolHandle< T > &hndl, const std::string &doc="none") const
template<class T >
Property * | declareProperty (const std::string &name, ToolHandleArray< T > &hndlArr, const std::string &doc="none") const
SmartIF< IMonitorSvc > & | monitorSvc () const
| Access the monitor service. More...
template<class T >
void | declareInfo (const std::string &name, const T &var, const std::string &desc) const
| Declare monitoring information. More...
void | declareInfo (const std::string &name, const std::string &format, const void *var, int size, const std::string &desc) const
| Declare monitoring information (special case) More...
template<class TYPE >
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
EventContext * | getContext () const
| get the context More...
void | setContext (EventContext *context)
| set the context More...
virtual std::vector< Gaudi::DataHandle * > | inputHandles () const override
virtual std::vector< Gaudi::DataHandle * > | outputHandles () const override
virtual const DataObjIDColl & | extraInputDeps () const override
virtual const DataObjIDColl & | extraOutputDeps () const override
virtual void | acceptDHVisitor (IDataHandleVisitor *) const override
const DataObjIDColl & | inputDataObjs () const
const DataObjIDColl & | outputDataObjs () const
void | commitHandles () override
void | registerTool (IAlgTool *tool) const
void | deregisterTool (IAlgTool *tool) const
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
const std::vector< IAlgTool * > & | tools () const
bool | isClonable () const override
| Specifies the clonability of the algorithm. More...
unsigned int | cardinality () const override
| Return the cardinality. More...
const std::vector< std::string > & | neededResources () const override
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...

## Protected Member Functions
StatusCode | decodeNames ()
| Decode a vector of string. More...
Protected Member Functions inherited from GaudiCommon< Algorithm >
| ~GaudiCommon () override=default
| Destructor. More...
StatusCode | releaseTool (const IAlgTool *tool) const
| manual forced (and 'safe') release of the tool More...
StatusCode | releaseSvc (const IInterface *svc) const
| manual forced (and 'safe') release of the service More...
Protected Member Functions inherited from Algorithm
virtual void | declareInput (Gaudi::DataHandle *im) override
virtual void | declareOutput (Gaudi::DataHandle *im) override
std::vector< IAlgTool * > & | tools ()
bool | isInitialized () const override
| Has the Algorithm already been initialized? More...
bool | isFinalized () const override
| Has the Algorithm already been finalized? More...
void | setIndex (const unsigned int &idx) override
| set instantiation index of Alg More...
Protected Member Functions inherited from CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > >
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...

## Private Member Functions
| GaudiSequencer (const GaudiSequencer &a)
| Private copy, copy not allowed. More...
GaudiSequencer & | operator= (const GaudiSequencer &a)
| Private assignment operator: This is not allowed. More...

## Private Attributes
StringArrayProperty | m_names
| Input string, list of algorithms. More...
std::vector< AlgorithmEntry > | m_entries
| List of algorithms to process. More...
bool | m_modeOR
| Indicates that the OR is wanted instead of AND. More...
bool | m_shortCircuit
| Indicates whether to stop processing as soon as possible, or to always execute all subalgorithms. More...
bool | m_ignoreFilter
| True if one continues always. More...
bool | m_isInitialized
| Indicate that we are ready. More...
bool | m_measureTime
| Flag to measure time. More...
bool | m_returnOK
| Forces the sequencer to return a good status. More...
ISequencerTimerTool * | m_timerTool = nullptr
| Pointer to the timer tool. More...
int | m_timer
| Timer number for the sequencer. More...

## Additional Inherited Members
Public Types inherited from Algorithm
typedef Gaudi::PluginService::Factory< IAlgorithm *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > >
using | base_class = CommonMessaging
Protected Types inherited from GaudiCommon< Algorithm >
using | base_class = Algorithm
typedef std::map< std::string, StatEntity > | Statistics
| the actual type of general counters More...
typedef std::map< std::string, unsigned int > | Counter
| the actual type error/warning counter More...
typedef std::vector< IAlgTool * > | AlgTools
| storage for active tools More...
typedef std::vector< SmartIF< IService > > | Services
| storage for active services More...
Protected Attributes inherited from GaudiCommon< Algorithm >
SmartIF< ICounterSummarySvc > | m_counterSummarySvc
| a pointer to the CounterSummarySvc More...
std::vector< std::string > | m_counterList
| list of counters to declare. Set by property CounterList. This can be a regular expression. More...
std::vector< std::string > | m_statEntityList
Protected Attributes inherited from Algorithm
EventContext * | m_event_context
| Event specific data for multiple event processing. More...
SmartIF< PropertyMgr > | m_propertyMgr
| For management of properties. More...
std::unique_ptr< IDataHandleVisitor > | m_updateDataHandles
| Hook for for derived classes to provide a custom visitor for data handles. More...
Static Protected Attributes inherited from GaudiCommon< Algorithm >
static const bool | IgnoreRootInTES
| Simple definition to be used with the new useRootInTES argument get<TYPE> and put methods. More...
static const bool | UseRootInTES
| Simple definition to be used with the new useRootInTES argument get<TYPE> and put methods. More...

## Detailed Description

Sequencer for executing several algorithms, stopping when one is faulty.

Default behaviour (ModeOR=False) is to execute all algorithms until one returns filterPassed() = False. If ShortCircuit is set to False, then all algorithms will be executed.

In OR mode, the logic is opposite. All algorithms until one returns filterPassed() = True. To then exit one must onter-intuitively set ShortCircuit to False. If the default value ShortCircuit=True is left then all algorithms will be executed.

Author
  Olivier Callot

Date
  2004-05-13

Definition at line 26 of file GaudiSequencer.h.

## Constructor & Destructor Documentation

GaudiSequencer::GaudiSequencer | ( | const std::string & | name,
|  | ISvcLocator * | pSvcLocator
| ) |  |

Standard constructor.

Definition at line 91 of file GaudiSequencer.cpp.

93 : GaudiAlgorithm ( name , pSvcLocator )
94 {
95 declareProperty( "Members" , m_names );
96 declareProperty( "ModeOR" , m_modeOR = false );
97 declareProperty( "IgnoreFilterPassed" , m_ignoreFilter = false );
98 declareProperty( "MeasureTime" , m_measureTime = false );
99 declareProperty( "ReturnOK" , m_returnOK = false );
100 declareProperty( "ShortCircuit" , m_shortCircuit = true );
101
102 m_names.declareUpdateHandler (& GaudiSequencer::membershipHandler, this );
103 }
GaudiSequencer::membershipHandler
void membershipHandler(Property &theProp)
for asynchronous changes in the list of algorithms
Definition: GaudiSequencer.cpp:346
GaudiSequencer::m_shortCircuit
bool m_shortCircuit
Indicates whether to stop processing as soon as possible, or to always execute all subalgorithms...
Definition: GaudiSequencer.h:76
GaudiSequencer::m_returnOK
bool m_returnOK
Forces the sequencer to return a good status.
Definition: GaudiSequencer.h:82
GaudiSequencer::m_modeOR
bool m_modeOR
Indicates that the OR is wanted instead of AND.
Definition: GaudiSequencer.h:75
Property::declareUpdateHandler
virtual Property & declareUpdateHandler(std::function< void(Property &)> fun)
set new callback for update
Definition: Property.cpp:72
GaudiAlgorithm::declareProperty
Property * declareProperty(const std::string &name, DataObjectHandle< T > &hndl, const std::string &doc="none") const
Definition: GaudiAlgorithm.h:695
GaudiSequencer::m_measureTime
bool m_measureTime
Flag to measure time.
Definition: GaudiSequencer.h:81
GaudiSequencer::m_ignoreFilter
bool m_ignoreFilter
True if one continues always.
Definition: GaudiSequencer.h:79
GaudiAlgorithm::GaudiAlgorithm
GaudiAlgorithm()
GaudiSequencer::m_names
StringArrayProperty m_names
Input string, list of algorithms.
Definition: GaudiSequencer.h:73

GaudiSequencer::~GaudiSequencer | ( |  | ) |
| override default

Destructor.

GaudiSequencer::GaudiSequencer | ( | const GaudiSequencer & | a | ) |
| private

Private copy, copy not allowed.

## Member Function Documentation

StatusCode GaudiSequencer::beginRun | ( |  | ) |
| override

Algorithm beginRun.

Definition at line 228 of file GaudiSequencer.cpp.

228 {
229
230 if ( !isEnabled() ) return StatusCode::SUCCESS;
231 if (msgLevel(MSG::DEBUG)) debug() << "==> beginRun" << endmsg;
232 return StatusCode::SUCCESS;
233 }
MSG::DEBUG
Definition: IMessageSvc.h:18
StatusCode::SUCCESS
Definition: StatusCode.h:30
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:127
Algorithm::isEnabled
bool isEnabled() const override
Is this algorithm enabled or disabled?
Definition: Algorithm.cpp:853
CommonMessagingBase::msgLevel
MSG::Level msgLevel() const
get the output level from the embedded MsgStream
Definition: CommonMessaging.h:136
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

StatusCode GaudiSequencer::decodeNames | ( |  | ) |
| protected

Decode a vector of string.

Definition at line 248 of file GaudiSequencer.cpp.

248 {
249
250 StatusCode final = StatusCode::SUCCESS;
251 m_entries.clear();
252
253 //== Get the "Context" option if in the file...
254 auto jos = service<IJobOptionsSvc>( "JobOptionsSvc" );
255
256 //= Get the Application manager, to see if algorithm exist
257 auto appMgr = service<IAlgManager>("ApplicationMgr");
258 for (const auto& item : m_names.value() ) {
259 const Gaudi::Utils::TypeNameString typeName(item);
260 const std::string &theName = typeName.name();
261 const std::string &theType = typeName.type();
262
263 //== Check wether the specified algorithm already exists. If not, create it
264 StatusCode result = StatusCode::SUCCESS;
265 SmartIF<IAlgorithm> myIAlg = appMgr->algorithm(typeName, false); // do not create it now
266 if ( !myIAlg ) {
267 // ensure some magic properties are set while we create the subalgorithm so
268 // that it effectively inherites 'our' settings -- if they have non-default
269 // values... and are not set explicitly already.
270 populate_JobOptionsSvc_t populate_guard{ theName, jos,
271 std::forward_as_tuple( "Context", context() ),
272 std::forward_as_tuple( "RootInTES", rootInTES() )
273 };
274 Algorithm *myAlg = nullptr;
275 result = createSubAlgorithm( theType, theName, myAlg );
276 myIAlg = myAlg; // ensure that myIAlg.isValid() from here onwards!
277 } else {
278 Algorithm *myAlg = dynamic_cast<Algorithm*>(myIAlg.get());
279 if (myAlg) {
280 subAlgorithms()->push_back(myAlg);
281 // when the algorithm is not created, the ref count is short by one, so we have to fix it.
282 myAlg->addRef();
283 }
284 }
285
286 // propagate the sub-algorithm into own state.
287 if ( result.isSuccess () &&
288 Gaudi::StateMachine::INITIALIZED <= FSMState() &&
289 myIAlg &&
290 Gaudi::StateMachine::INITIALIZED > myIAlg->FSMState() )
291 {
292 StatusCode sc = myIAlg->sysInitialize() ;
293 if ( sc.isFailure() ) { result = sc ; }
294 }
295
296 // propagate the sub-algorithm into own state.
297 if ( result.isSuccess () &&
298 Gaudi::StateMachine::RUNNING <= FSMState() &&
299 myIAlg &&
300 Gaudi::StateMachine::RUNNING > myIAlg->FSMState() )
301 {
302 StatusCode sc = myIAlg->sysStart () ;
303 if ( sc.isFailure() ) { result = sc ; }
304 }
305
306 //== Is it an Algorithm ? Strange test...
307 if ( result.isSuccess() ) {
308 // TODO: (MCl) it is possible to avoid the dynamic_cast in most of the
309 // cases by keeping the result of createSubAlgorithm.
310 Algorithm* myAlg = dynamic_cast<Algorithm*>(myIAlg.get());
311 if (myAlg) {
312 // Note: The reference counting is kept by the system of sub-algorithms
313 m_entries.emplace_back( myAlg );
314 if (msgLevel(MSG::DEBUG)) debug () << "Added algorithm " << theName << endmsg;
315 } else {
316 warning() << theName << " is not an Algorithm - failed dynamic_cast"
317 << endmsg;
318 final = StatusCode::FAILURE;
319 }
320 } else {
321 warning() << "Unable to find or create " << theName << endmsg;
322 final = result;
323 }
324
325 }
326
327 //== Print the list of algorithms
328 MsgStream& msg = info();
329 if ( m_modeOR ) msg << "OR ";
330 msg << "Member list: ";
331 ostream_joiner( msg, m_entries, ", ", [](const AlgorithmEntry& e) {
332 Algorithm* alg = e.algorithm();
333 std::string typ = System::typeinfoName( typeid( *alg) ) ;
334 return ( alg->name() == typ ) ? alg->name() : ( typ + "/" + alg->name() );
335 } );
336 if ( !isDefault(context()) ) msg << ", with context '" << context() << "'";
337 if ( !isDefault(rootInTES()) ) msg << ", with rootInTES '" << rootInTES() << "'";
338 msg << endmsg;
339
340 return final;
341 }
MsgStream
Definition of the MsgStream class used to transmit messages.
Definition: MsgStream.h:24
Gaudi::StateMachine::INITIALIZED
Definition: StateMachine.h:15
SmartIF< IAlgorithm >
CommonMessagingBase::msg
MsgStream & msg() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:133
Algorithm::createSubAlgorithm
StatusCode createSubAlgorithm(const std::string &type, const std::string &name, Algorithm *&pSubAlg)
Create a sub algorithm.
Definition: Algorithm.cpp:955
std::forward_as_tuple
T forward_as_tuple(T...args)
IAlgorithm::sysStart
virtual StatusCode sysStart()=0
Startup method invoked by the framework.
GaudiCommon< Algorithm >::rootInTES
const std::string & rootInTES() const
Returns the "rootInTES" string.
Definition: GaudiCommon.h:716
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:124
GaudiSequencer::m_modeOR
bool m_modeOR
Indicates that the OR is wanted instead of AND.
Definition: GaudiSequencer.h:75
System::typeinfoName
GAUDI_API const std::string typeinfoName(const std::type_info &)
Get platform independent information about the class type.
Definition: System.cpp:297
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:76
MSG::DEBUG
Definition: IMessageSvc.h:18
GaudiCommon< Algorithm >::context
const std::string & context() const
Returns the "context" string. Used to identify different processing states.
Definition: GaudiCommon.h:712
merge_files.sc
int sc
Definition: merge_files.py:167
StatusCode::isFailure
bool isFailure() const
Test for a status code of FAILURE.
Definition: StatusCode.h:86
IAlgorithm::sysInitialize
virtual StatusCode sysInitialize()=0
Initialization method invoked by the framework.
std::string
STL class.
Algorithm::name
const std::string & name() const override
The identifying name of the algorithm object.
Definition: Algorithm.cpp:820
SmartIF::get
TYPE * get() const
Get interface pointer.
Definition: SmartIF.h:76
std::vector::push_back
T push_back(T...args)
Gaudi::Utils::TypeNameString
Helper class to parse a string of format "type/name".
Definition: TypeNameString.h:9
CommonMessagingBase::warning
MsgStream & warning() const
shortcut for the method msgStream(MSG::WARNING)
Definition: CommonMessaging.h:121
StatusCode::FAILURE
Definition: StatusCode.h:29
StatusCode::SUCCESS
Definition: StatusCode.h:30
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
PropertyWithValue::value
const TYPE & value() const
explicit conversion
Definition: Property.h:341
GaudiUtils::details::ostream_joiner
Stream & ostream_joiner(Stream &os, Iterator first, Iterator last, Separator sep, OutputElement output=OutputElement{})
Definition: SerializeSTL.h:35
Algorithm::subAlgorithms
const std::vector< Algorithm * > * subAlgorithms() const
List of sub-algorithms. Returns a pointer to a vector of (sub) Algorithms.
Definition: Algorithm.cpp:865
Algorithm
Base class from which all concrete algorithm classes should be derived.
Definition: Algorithm.h:74
Gaudi::StateMachine::RUNNING
Definition: StateMachine.h:16
Algorithm::FSMState
Gaudi::StateMachine::State FSMState() const override
returns the current state of the algorithm
Definition: Algorithm.h:193
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:127
ana.item
tuple item
print s1,s2
Definition: ana.py:146
IOTest.appMgr
tuple appMgr
Definition: IOTest.py:83
GaudiDict::typeName
std::string typeName(const std::type_info &typ)
Definition: Dictionary.cpp:21
CommonMessagingBase::msgLevel
MSG::Level msgLevel() const
get the output level from the embedded MsgStream
Definition: CommonMessaging.h:136
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244
GaudiSequencer::m_entries
std::vector< AlgorithmEntry > m_entries
List of algorithms to process.
Definition: GaudiSequencer.h:74
GaudiSequencer::m_names
StringArrayProperty m_names
Input string, list of algorithms.
Definition: GaudiSequencer.h:73

StatusCode GaudiSequencer::endRun | ( |  | ) |
| override

Algorithm endRun.

Definition at line 238 of file GaudiSequencer.cpp.

238 {
239
240 if ( !isEnabled() ) return StatusCode::SUCCESS;
241 if (msgLevel(MSG::DEBUG)) debug() << "==> endRun" << endmsg;
242 return StatusCode::SUCCESS;
243 }
MSG::DEBUG
Definition: IMessageSvc.h:18
StatusCode::SUCCESS
Definition: StatusCode.h:30
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:127
Algorithm::isEnabled
bool isEnabled() const override
Is this algorithm enabled or disabled?
Definition: Algorithm.cpp:853
CommonMessagingBase::msgLevel
MSG::Level msgLevel() const
get the output level from the embedded MsgStream
Definition: CommonMessaging.h:136
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

StatusCode GaudiSequencer::execute | ( |  | ) |
| override

Algorithm execution.

Definition at line 146 of file GaudiSequencer.cpp.

146 {
147
148 if ( m_measureTime ) m_timerTool->start( m_timer );
149
150 if (msgLevel(MSG::DEBUG)) debug() << "==> Execute" << endmsg;
151
152 StatusCode result = StatusCode(StatusCode::SUCCESS, true);
153
154 bool seqPass = !m_modeOR; // for OR, result will be false, unless (at least) one is true
155 // for AND, result will be true, unless (at least) one is false
156 // also see comment below ....
157
158 for (auto& entry : m_entries) {
159 Algorithm* myAlg = entry.algorithm();
160 if ( ! myAlg->isEnabled() ) continue;
161 if ( ! myAlg->isExecuted() ) {
162
163 //DF: if we have a context set by GaudiHive scheduler propagate it to the children
164 if(getContext())
165 myAlg->setContext(getContext());
166
167 if ( m_measureTime ) m_timerTool->start( entry.timer() );
168 result = myAlg->sysExecute();
169 if ( m_measureTime ) m_timerTool->stop( entry.timer() );
170 myAlg->setExecuted( true );
171 if ( ! result.isSuccess() ) break; //== Abort and return bad status
172 }
173 //== Check the returned status
174 if ( !m_ignoreFilter ) {
175 bool passed = myAlg->filterPassed();
176 if (msgLevel(MSG::VERBOSE))
177 verbose() << "Algorithm " << myAlg->name() << " returned filter passed "
178 << (passed ? "true" : "false") << endmsg;
179 if ( entry.reverse() ) passed = !passed;
180
181
182 //== indicate our own result. For OR, exit as soon as true.
183 // If no more, will exit with false.
184 //== for AND, exit as soon as false. Else, will be true (default)
185
186 // if not short-circuiting, make sure we latch iPass to 'true' in
187 // OR mode (i.e. it is sufficient for one item to be true in order
188 // to be true at the end, and thus we start out at 'false'), and latch
189 // to 'false' in AND mode (i.e. it is sufficient for one item to
190 // be false to the false in the end, and thus we start out at 'true')
191 // -- i.e. we should not just blindly return the 'last' passed status!
192
193 // or to put it another way: in OR mode, we don't care about things
194 // which are false, as they leave our current state alone (provided
195 // we stared as 'false'!), and in AND mode, we keep our current
196 // state until someone returns 'false' (provided we started as 'true')
197 if ( m_modeOR ? passed : !passed ) {
198 seqPass = passed;
199 if (msgLevel(MSG::VERBOSE))
200 verbose() << "SeqPass is now " << (seqPass ? "true" : "false") << endmsg;
201 if (m_shortCircuit) break;
202 }
203 }
204
205 }
206 if (msgLevel(MSG::VERBOSE))
207 verbose() << "SeqPass is " << (seqPass ? "true" : "false") << endmsg;
208 if ( !m_ignoreFilter && !m_entries.empty() ) setFilterPassed( seqPass );
209 setExecuted( true );
210
211 if ( m_measureTime ) m_timerTool->stop( m_timer );
212
213 return m_returnOK ? (result.ignore(), StatusCode::SUCCESS) : result;
214 }
GaudiSequencer::m_shortCircuit
bool m_shortCircuit
Indicates whether to stop processing as soon as possible, or to always execute all subalgorithms...
Definition: GaudiSequencer.h:76
GaudiSequencer::m_returnOK
bool m_returnOK
Forces the sequencer to return a good status.
Definition: GaudiSequencer.h:82
GaudiSequencer::m_modeOR
bool m_modeOR
Indicates that the OR is wanted instead of AND.
Definition: GaudiSequencer.h:75
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:76
CommonMessagingBase::verbose
MsgStream & verbose() const
shortcut for the method msgStream(MSG::VERBOSE)
Definition: CommonMessaging.h:130
MSG::DEBUG
Definition: IMessageSvc.h:18
Algorithm::filterPassed
bool filterPassed() const override
Did this algorithm pass or fail its filter criterion for the last event?
Definition: Algorithm.cpp:857
Algorithm::getContext
EventContext * getContext() const
get the context
Definition: Algorithm.h:571
MSG::VERBOSE
Definition: IMessageSvc.h:17
Algorithm::setContext
void setContext(EventContext *context)
set the context
Definition: Algorithm.h:574
Algorithm::name
const std::string & name() const override
The identifying name of the algorithm object.
Definition: Algorithm.cpp:820
GaudiSequencer::m_timerTool
ISequencerTimerTool * m_timerTool
Pointer to the timer tool.
Definition: GaudiSequencer.h:83
Algorithm::setExecuted
void setExecuted(bool state) override
Set the executed flag to the specified state.
Definition: Algorithm.cpp:844
StatusCode::SUCCESS
Definition: StatusCode.h:30
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
Algorithm::sysExecute
StatusCode sysExecute() override
The actions to be performed by the algorithm on an event.
Definition: Algorithm.cpp:567
GaudiSequencer::m_measureTime
bool m_measureTime
Flag to measure time.
Definition: GaudiSequencer.h:81
Algorithm::isExecuted
bool isExecuted() const override
Has this algorithm been executed since the last reset?
Definition: Algorithm.cpp:840
ISequencerTimerTool::start
virtual void start(int index)=0
start the counter, i.e.
Algorithm
Base class from which all concrete algorithm classes should be derived.
Definition: Algorithm.h:74
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:127
Algorithm::isEnabled
bool isEnabled() const override
Is this algorithm enabled or disabled?
Definition: Algorithm.cpp:853
StatusCode::ignore
void ignore() const
Definition: StatusCode.h:108
CommonMessagingBase::msgLevel
MSG::Level msgLevel() const
get the output level from the embedded MsgStream
Definition: CommonMessaging.h:136
ISequencerTimerTool::stop
virtual double stop(int index)=0
stop the counter, return the elapsed time
Algorithm::setFilterPassed
void setFilterPassed(bool state) override
Set the filter passed flag to the specified state.
Definition: Algorithm.cpp:861
GaudiSequencer::m_ignoreFilter
bool m_ignoreFilter
True if one continues always.
Definition: GaudiSequencer.h:79
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244
GaudiSequencer::m_timer
int m_timer
Timer number for the sequencer.
Definition: GaudiSequencer.h:84
GaudiSequencer::m_entries
std::vector< AlgorithmEntry > m_entries
List of algorithms to process.
Definition: GaudiSequencer.h:74

StatusCode GaudiSequencer::finalize | ( |  | ) |
| override

Algorithm finalization.

Definition at line 219 of file GaudiSequencer.cpp.

219 {
220
221 if (msgLevel(MSG::DEBUG)) debug() << "==> Finalize" << endmsg;
222 return GaudiAlgorithm::finalize();
223 }
MSG::DEBUG
Definition: IMessageSvc.h:18
GaudiAlgorithm::finalize
StatusCode finalize() override
standard finalization method
Definition: GaudiAlgorithm.cpp:62
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:127
CommonMessagingBase::msgLevel
MSG::Level msgLevel() const
get the output level from the embedded MsgStream
Definition: CommonMessaging.h:136
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

StatusCode GaudiSequencer::initialize | ( |  | ) |
| override

Algorithm initialization.

Definition at line 107 of file GaudiSequencer.cpp.

107 {
108 GaudiAlgorithm::initialize();
109
110 if (msgLevel(MSG::DEBUG)) debug() << "==> Initialise" << endmsg;
111
112 StatusCode status = decodeNames();
113 if ( !status.isSuccess() ) return status;
114
115 m_timerTool = tool<ISequencerTimerTool>( "SequencerTimerTool" );
116 if ( m_timerTool->globalTiming() ) m_measureTime = true;
117
118 if ( m_measureTime ) {
119 m_timer = m_timerTool->addTimer( name() );
120 m_timerTool->increaseIndent();
121 } else {
122 release( m_timerTool );
123 m_timerTool = nullptr;
124 }
125
126 //== Initialize the algorithms
127 for (auto& entry : m_entries ) {
128 if ( m_measureTime ) {
129 entry.setTimer( m_timerTool->addTimer( entry.algorithm()->name() ) );
130 }
131
132 status = entry.algorithm()->sysInitialize();
133 if ( !status.isSuccess() ) {
134 return Error( "Can not initialize " + entry.algorithm()->name(),
135 status );
136 }
137 }
138 if ( m_measureTime ) m_timerTool->decreaseIndent();
139
140 return StatusCode::SUCCESS;
141 }
ISequencerTimerTool::decreaseIndent
virtual void decreaseIndent()=0
Decrease the indentation of the name.
ISequencerTimerTool::addTimer
virtual int addTimer(const std::string &name)=0
add a timer entry with the specified name
GaudiAlgorithm::initialize
StatusCode initialize() override
standard initialization method
Definition: GaudiAlgorithm.cpp:48
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:76
GaudiCommon< Algorithm >::Error
StatusCode Error(const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
Print the error message and return with the given StatusCode.
MSG::DEBUG
Definition: IMessageSvc.h:18
ISequencerTimerTool::increaseIndent
virtual void increaseIndent()=0
Increase the indentation of the name.
ISequencerTimerTool::globalTiming
virtual bool globalTiming()=0
returns the flag telling that global timing is wanted
Algorithm::name
const std::string & name() const override
The identifying name of the algorithm object.
Definition: Algorithm.cpp:820
GaudiSequencer::m_timerTool
ISequencerTimerTool * m_timerTool
Pointer to the timer tool.
Definition: GaudiSequencer.h:83
StatusCode::SUCCESS
Definition: StatusCode.h:30
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
GaudiSequencer::m_measureTime
bool m_measureTime
Flag to measure time.
Definition: GaudiSequencer.h:81
GaudiSequencer::decodeNames
StatusCode decodeNames()
Decode a vector of string.
Definition: GaudiSequencer.cpp:248
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:127
CommonMessagingBase::msgLevel
MSG::Level msgLevel() const
get the output level from the embedded MsgStream
Definition: CommonMessaging.h:136
GaudiCommon< Algorithm >::release
StatusCode release(const IInterface *interface) const
Manual forced (and 'safe') release of the active tool or service.
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244
GaudiSequencer::m_timer
int m_timer
Timer number for the sequencer.
Definition: GaudiSequencer.h:84
GaudiSequencer::m_entries
std::vector< AlgorithmEntry > m_entries
List of algorithms to process.
Definition: GaudiSequencer.h:74

void GaudiSequencer::membershipHandler | ( | Property & | theProp | ) |

for asynchronous changes in the list of algorithms

Definition at line 346 of file GaudiSequencer.cpp.

347 {
348 // no action for not-yet initialized sequencer
349 if ( Gaudi::StateMachine::INITIALIZED > FSMState() ) { return ; } // RETURN
350
351 decodeNames().ignore();
352
353 if ( !m_measureTime ) { return ; } // RETURN
354
355 // add the entries into timer table:
356
357 if ( !m_timerTool )
358 { m_timerTool = tool<ISequencerTimerTool>( "SequencerTimerTool" ) ; }
359
360 if ( m_timerTool->globalTiming() ) m_measureTime = true;
361
362 m_timer = m_timerTool->addTimer( name() );
363 m_timerTool->increaseIndent();
364
365 for ( auto& entry : m_entries )
366 {
367 entry.setTimer( m_timerTool->addTimer( entry.algorithm()->name() ) );
368 }
369
370 m_timerTool->decreaseIndent();
371
372 }
Gaudi::StateMachine::INITIALIZED
Definition: StateMachine.h:15
ISequencerTimerTool::decreaseIndent
virtual void decreaseIndent()=0
Decrease the indentation of the name.
ISequencerTimerTool::addTimer
virtual int addTimer(const std::string &name)=0
add a timer entry with the specified name
ISequencerTimerTool::increaseIndent
virtual void increaseIndent()=0
Increase the indentation of the name.
ISequencerTimerTool::globalTiming
virtual bool globalTiming()=0
returns the flag telling that global timing is wanted
Algorithm::name
const std::string & name() const override
The identifying name of the algorithm object.
Definition: Algorithm.cpp:820
GaudiSequencer::m_timerTool
ISequencerTimerTool * m_timerTool
Pointer to the timer tool.
Definition: GaudiSequencer.h:83
GaudiSequencer::m_measureTime
bool m_measureTime
Flag to measure time.
Definition: GaudiSequencer.h:81
GaudiSequencer::decodeNames
StatusCode decodeNames()
Decode a vector of string.
Definition: GaudiSequencer.cpp:248
Algorithm::FSMState
Gaudi::StateMachine::State FSMState() const override
returns the current state of the algorithm
Definition: Algorithm.h:193
StatusCode::ignore
void ignore() const
Definition: StatusCode.h:108
GaudiSequencer::m_timer
int m_timer
Timer number for the sequencer.
Definition: GaudiSequencer.h:84
GaudiSequencer::m_entries
std::vector< AlgorithmEntry > m_entries
List of algorithms to process.
Definition: GaudiSequencer.h:74

GaudiSequencer& GaudiSequencer::operator= | ( | const GaudiSequencer & | a | ) |
| private

Private assignment operator: This is not allowed.

## Member Data Documentation

std::vector<AlgorithmEntry> GaudiSequencer::m_entries
| private

List of algorithms to process.

Definition at line 74 of file GaudiSequencer.h.

bool GaudiSequencer::m_ignoreFilter
| private

True if one continues always.

Definition at line 79 of file GaudiSequencer.h.

bool GaudiSequencer::m_isInitialized
| private

Indicate that we are ready.

Definition at line 80 of file GaudiSequencer.h.

bool GaudiSequencer::m_measureTime
| private

Flag to measure time.

Definition at line 81 of file GaudiSequencer.h.

bool GaudiSequencer::m_modeOR
| private

Indicates that the OR is wanted instead of AND.

Definition at line 75 of file GaudiSequencer.h.

StringArrayProperty GaudiSequencer::m_names
| private

Input string, list of algorithms.

Definition at line 73 of file GaudiSequencer.h.

bool GaudiSequencer::m_returnOK
| private

Forces the sequencer to return a good status.

Definition at line 82 of file GaudiSequencer.h.

bool GaudiSequencer::m_shortCircuit
| private

Indicates whether to stop processing as soon as possible, or to always execute all subalgorithms.

In MOdeOR=True the behaviour is the exact opposite.

Definition at line 76 of file GaudiSequencer.h.

int GaudiSequencer::m_timer
| private

Timer number for the sequencer.

Definition at line 84 of file GaudiSequencer.h.

ISequencerTimerTool* GaudiSequencer::m_timerTool = nullptr
| private

Pointer to the timer tool.

Definition at line 83 of file GaudiSequencer.h.

The documentation for this class was generated from the following files:

- GaudiAlg/GaudiAlg/GaudiSequencer.h
- GaudiAlg/src/lib/GaudiSequencer.cpp